<template>
  <div class="register">
    <div class="title-wrapper d-flex align-items-center">
      {{ $t('auth.whitelist.title') }}
    </div>
    <div class="content-wrapper">
      <div class="sub-title">
        {{ $t('auth.whitelist.sub_title') }}
      </div>
      <div class="input-wrapper d-flex align-items-center">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-email"></i></span>
        </div>
        <input v-model="whitelist.email"
           @focus="resetError"
           @keyup.enter="register"
           v-validate="'required|max:255'"
           :placeholder="$t('auth.placeholder.email')"
           name="email"
           data-vv-validate-on="none"
           type="email"
           class="form-control w-100 input_form">
        <span class="invalid-feedback" v-if="errors.has('email')">{{ errors.first('email') }}</span>
      </div>

      <div class="input-wrapper d-flex align-items-center">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-name"></i></span>
        </div>
        <input data-vv-as="full name"
           v-model="whitelist.name"
           @focus="resetError"
           @keyup.enter="register"
           v-validate="'required|max:255'"
           :placeholder="$t('auth.placeholder.full_name')"
           data-vv-validate-on="none"
           name="name"
           type="text"
           class="form-control w-100 input_form">
        <span class="invalid-feedback" v-if="errors.has('name')">{{ errors.first('name') }}</span>
      </div>

      <div class="input-wrapper d-flex align-items-center">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-ETH_1"></i></span>
        </div>
        <input
          data-vv-as="ETH address"
          v-model="whitelist.eth_address"
          @focus="resetError"
          @keyup.enter="register"
          v-validate="'required|max:255|is_eth_address'"
          :placeholder="$t('auth.placeholder.eth_address')"
          data-vv-validate-on="none"
          name="eth_address"
          type="text"
          class="form-control w-100 input_form">
        <span class="invalid-feedback" v-if="errors.has('eth_address')">{{ errors.first('eth_address') }}</span>
      </div>

      <div class="input-wrapper d-flex align-items-center">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-ETH_1"></i></span>
        </div>
        <currency-input
          :precision="18"
          data-vv-as="ETH amount"
          v-model="whitelist.eth_amount"
          @focus="resetError"
          @keyup.enter="register"
          v-validate="'required|gt:0'"
          :placeholder="$t('auth.placeholder.eth_amount')"
          data-vv-validate-on="none"
          name="eth_amount"
          class="form-control w-100 input_form">
        </currency-input>
        <span class="invalid-feedback" v-if="errors.has('eth_amount')">{{ errors.first('eth_amount') }}</span>
      </div>
      <div class="submit-btn text-center">
        <button type="button" @click="register" class="button-primary">{{ $t('auth.btn.upper_register') }}</button>
      </div>

      <div class="below-wrapper position-relative row form-group" v-if="!$isAuthenticated">
        <div class="text-center">
          <div class="position-relative form-check form-check-inline">
            <label class="form-check-label">
              {{ $t('auth.register.note') }}
              <a class="login-text text-orange" href="javascript:void(0)" @click="goToLoginPage">{{ $t('auth.btn.login') }}</a>
            </label>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import rf from '../../common/requests/RequestFactory';
import CurrencyInput from '../components/CurrencyInput.vue';

export default {
  components: {
    CurrencyInput
  },
  data() {
    return {
      whitelist: {
        email: '',
        name: '',
        eth_address: '',
        eth_amount: '',
      }
    };
  },
  methods: {
    resetError () {
      this.errors.clear();
    },
    goToLoginPage() {
      this.$router.push("/login");
    },
    register () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          rf.getRequest('WhitelistRequest').create(this.whitelist)
            .then(res => {
              Object.assign(this.whitelist, {
                email: '',
                name: '',
                eth_address: '',
                eth_amount: '',
              });

              this.$toasted.show('You register successful!', {
                theme: 'bubble',
                position: 'top-right',
                duration : 2000
              });
            })
            .catch((error) => {
              const errors = error.errors;
              this.errors.clear();
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
            });
        });
    },
  },
}
</script>
<style lang="scss" scoped>
  @import "../../../sass/mobile/typoVariables";

  .register {
    height: calc(100vh - 168rem);
    min-height: 450rem;
    background: $bg_primary;
    font-size: $medium;
    .title-wrapper {
      font-size: 18rem;
      padding-left: 13rem;
      background-color: #21335b;
      height: 55rem;
      line-height: initial;
      color: $white;
    }
    .content-wrapper {
      padding: 10rem $tiny 0 $tiny;
      input:-webkit-autofill,
      input:-webkit-autofill:hover,
      input:-webkit-autofill:focus textarea:-webkit-autofill,
      select:-webkit-autofill,
      select:-webkit-autofill:hover,
      select:-webkit-autofill:focus {
        border: none;
        -webkit-text-fill-color: #000;
        -webkit-box-shadow: 0 0 0rem 1000rem $white inset;
      }
      .sub-title {
        font-size: 14rem;
        margin-top: 20rem;
        font-weight: normal;
        font-style: normal;
        font-stretch: normal;
        line-height: normal;
        letter-spacing: normal;
        color: #818181;
      }
      .invalid-feedback {
        font-size: 13rem;
        color: red;
        display: block;
        padding-left: $tiny;
      }
      .input-wrapper {
        height: 40rem;
        border-radius: 74rem;
        background-color: $white;
        margin-top: 20rem;
        position: relative;
        input {
          @extend .Medium-14;
          color: #000;
          border: 1rem solid transparent;
          outline: none;
          &::placeholder {
            color: #cacaca;
          }
        }
      }
      .submit-btn {
        margin-top: 25rem;
        button {
          @extend .button-12;
          background: transparent;
          width: 295rem;
          height: 32rem;
          outline: none;
          border-radius: 30rem !important;
          border: solid 1rem #fa7300;
          color: #fa7300;
          font-weight: bold;
          letter-spacing: 0.5rem;
        }
      }
      .agree-wrapper {
        padding: 19rem 0 12rem 0;
        @extend .Medium-14;
        color: #989898;
        .form-check {
          display: table;
          input {
            display: table-cell;
            vertical-align: middle;
            margin-top: -1rem;
            margin-right: 7rem;
            background-color: #e0e0e0;
          }
          label {
            display: table-cell;
            vertical-align: middle;
          }
        }
      }
      .below-wrapper {
        @extend .Medium-14;
        color: #989898;
        padding: 23rem 0;
        .login-text {
          font-size: $tiny;
          font-weight: bold;
          letter-spacing: 0.5rem;
        }
      }
    }
  }

  .invalid-feedback {
    color: red;
    position: absolute;
    text-align: left;
    bottom: -20rem;
    font-size: 10rem;
    left: 5rem;
  }

  .input_form {
    border: 1px solid transparent;
    color: #000;
    padding-left: 40rem;
    height: 100%;
    border-radius: 74rem;
    outline: none;
    &:focus {
      box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
    }
  }

  .button-primary {
    width: 122rem !important;
    height: 35rem !important;
    border-radius: 30rem !important;
    background-color: #fa7300 !important;

    border: none !important;
    outline: none !important;
    color: white !important;
    cursor: pointer !important;
    letter-spacing: 1rem !important;
    font-weight: bold !important;
  }

  .input_group_prepend {
    width: 19px;
    display: inline-block;
    margin-left: 16rem;
    line-height: 45rem;
    font-size: 15.5rem;
    position: absolute;
    color: #B0B0B0;
  }

</style>
